package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.entity.Merchant;
import com.gxwebsoft.shop.service.MerchantChargePackageService;
import com.gxwebsoft.shop.entity.MerchantChargePackage;
import com.gxwebsoft.shop.param.MerchantChargePackageParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.MerchantService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * 商家充值套餐控制器
 *
 * @author 科技小王子
 * @since 2024-11-20 01:55:04
 */
@Api(tags = "商家充值套餐管理")
@RestController
@RequestMapping("/api/shop/merchant-charge-package")
public class MerchantChargePackageController extends BaseController {
    @Resource
    private MerchantChargePackageService merchantChargePackageService;
    @Resource
    private MerchantService merchantService;

    @ApiOperation("分页查询商家充值套餐")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantChargePackage>> page(MerchantChargePackageParam param) {
        // 使用关联查询
        return success(merchantChargePackageService.pageRel(param));
    }

    @ApiOperation("查询全部商家充值套餐")
    @GetMapping()
    public ApiResult<List<MerchantChargePackage>> list(MerchantChargePackageParam param) {
        // 使用关联查询
        if (param.getMerchantId() == null) {
            Merchant merchant = merchantService.getByUserId(getLoginUser().getUserId());
            if (merchant != null) param.setMerchantId(merchant.getMerchantId());
        }
        if (param.getMerchantId() != null) {
            return success(merchantChargePackageService.listRel(param));
        }
        return success(new ArrayList<>());
    }

    @PreAuthorize("hasAuthority('shop:merchantChargePackage:list')")
    @ApiOperation("根据id查询商家充值套餐")
    @GetMapping("/{id}")
    public ApiResult<MerchantChargePackage> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(merchantChargePackageService.getByIdRel(id));
    }

    @ApiOperation("添加商家充值套餐")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantChargePackage merchantChargePackage) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            merchantChargePackage.setUserId(loginUser.getUserId());
            Merchant merchant = merchantService.getByUserId(getLoginUser().getUserId());
            merchantChargePackage.setMerchantId(merchant.getMerchantId());
        }
        if (merchantChargePackageService.save(merchantChargePackage)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商家充值套餐")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantChargePackage merchantChargePackage) {
        if (merchantChargePackageService.updateById(merchantChargePackage)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商家充值套餐")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantChargePackageService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商家充值套餐")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantChargePackage> list) {
        if (merchantChargePackageService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商家充值套餐")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantChargePackage> batchParam) {
        if (batchParam.update(merchantChargePackageService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商家充值套餐")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantChargePackageService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
